      PROGRAM BERGER
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /MESH_SZ/ NPTS
      COMMON /MESH/ X(201)
      COMMON /COORD/ ICORD
      DIMENSION U(201),WORK(8+5*201),INFO(4)
      EXTERNAL RKC_F
C     
C     DEFINE THE PROBLEM PARAMETERS
C
      ICORD = 0
      NPTS = 201
      NPDE = 1
      INFO(1) = 1               ! Compute a solution Y(*) at TEND only.
      INFO(2) = 0               ! RKC is to compute the estimate internally.  
      INFO(3) = 0               ! The Jacobian may not be constant.
      INFO(4) = 0               ! ATOL is a double precision scalar.
      NEQN = NPDE * NPTS
      T = 0.
      TOUT = 0.
      EPS = 1.E-5
      DT = 1.E-8
C
C     DEFINE MESH AND INITIAL DATA
C
      DO 10 I=1,NPTS
         X(I) = FLOAT(I-1) * .005
 10      U(I) = TRUESOL(T,X(I))
 20    WRITE(3,25) T
       IDID=0
 25    FORMAT(//4H T= ,E10.3)
       WRITE(3,30) (U(I),I=1,NPTS)
 30    FORMAT(5E20.6)
       IF( T .GE. 1.1) STOP
       TOUT = TOUT + .1
C
C     CALL ODE INTEGRATOR 
C
       CALL RKC(NEQN,U,X,T,TOUT,EPS,EPS,INFO,WORK,IDID,F,D,BNDRY)
C       write(*,*) 'IDID=',IDID
       IF( IDID .EQ. 1 ) GO TO 20 
       WRITE(*,*) IDID
       STOP 
       END

      




      SUBROUTINE F(T,X,U,UX,DUXX,FVAL,NPDE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NPDE),UX(NPDE),DUXX(NPDE,NPDE),FVAL(NPDE)
C
C     F ROUTINE FOR BURGERS EQUATION
C
      FVAL(1) = DUXX(1,1) - U(1) * UX(1)
      RETURN
      END


      SUBROUTINE D(T,X,U,DVAL,NPDE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NPDE),DVAL(NPDE,NPDE)
C
C     D ROUTINE FOR BURGERS EQUATION
C
      DVAL(1,1) = .003
      RETURN
      END


      
      
      SUBROUTINE BNDRY(T,X,U,ALPHA,BETA,GAMMA,NPDE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NPDE),ALPHA(NPDE),BETA(NPDE),GAMMA(NPDE)
C
C     BNDRY ROUTINE FOR BURGERS EQUATION
C
      ALPHA(1) = 1.
      BETA(1) = 0.
C
C     TRUESOL IS A FUNCTION ROUTINE WHICH COMPUTES THE KNOWN TRUE SOLUTION
C
      GAMMA(1) = TRUESOL(T,X)
      RETURN
      END



      FUNCTION TRUESOL(T,X)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      ANU=3.E-3
      A = -(X-.5 + 4.95*T) / ( 20.*ANU)
      B = -(X-.5 + 0.75*T) / (  4.*ANU)
      C = -(X-.375) / (  2.*ANU)
      A = EXP(A)
      B = EXP(B)
      C = EXP(C)
      TRUESOL = ( .1*A + .5*B + C ) / ( A + B + C )
      RETURN
      END

