% PDEONE - Solve one dimensional PDE's using ALGORITHM 494 PDEONE
%
% Written by:
% -- 
% John L. Weatherwax                2005-12-17
% 
% email: wax@alum.mit.edu
% 
% Please send comments and especially bug reports to the
% above email address.
% 
%-----

%xGrid = linspace(0.0,1.0,21);
xGrid = linspace(0.0,1.0,41);
tGrid = [ 0 0.1 0.5 1.0 1.5 5.0 ];

coord="cylindrical"; 

[ U, opts ] = pdeone("F","D","BNDRY_ALPHA","BNDRY_BETA","BNDRY_GAMMA","cylindrical_init", ...
		     "xGrid", xGrid, "tGrid", tGrid, "Coordinate", coord, ...
		     "eps", 10^(-4), "dt", 10^(-7) );

tGrid = opts.tGrid; 
xGrid = opts.xGrid; 

close all; 
ntouts = length(tGrid); 
h=figure; 
for nti=1:ntouts,
  figure(h); 
  plot( xGrid, U(1,:,nti) ); grid; %title( [ 'U(1) at t(',num2str(nti),')' ] ); 
  hold on; 
  %pause;
end
