% PDEONE - Solve one dimensional PDE's using ALGORITHM 494 PDEONE
%
% Written by:
% -- 
% John L. Weatherwax                2005-12-17
% 
% email: wax@alum.mit.edu
% 
% Please send comments and especially bug reports to the
% above email address.
% 
%-----

xGrid = linspace(0.0,1.0,31);
tGrid = linspace( 0, 10^9, 10 );

[ U, opts ] = pdeone("F","D","BNDRY_ALPHA","BNDRY_BETA","BNDRY_GAMMA","chemical_init", ...
		     "xGrid", xGrid, "tGrid", tGrid, "eps", 10^(-4), "dt", 10^(-10) );

tGrid = opts.tGrid; 
xGrid = opts.xGrid; 

close all; 
ntouts = length(tGrid); 
h=figure; 
for nti=1:ntouts,
  figure; %figure(h); 
  subplot(1,4,1); plot( xGrid, U(1,:,nti) ); grid; 
  subplot(1,4,2); plot( xGrid, U(2,:,nti) ); grid; 
  subplot(1,4,3); plot( xGrid, U(3,:,nti) ); grid; 
  subplot(1,4,4); plot( xGrid, U(4,:,nti) ); grid; 
  %hold on; 
  %pause;
end
